'Demo of a SXGA Stripcharting code
'Each chart cog can graph 1024 points without using any HUB RAM
'Copyright 2008 Raymond Allen



CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


  'for display
  cols = 80
  rows = 64
  tiles = cols * rows
  vga_params = 21
  spacetile = $220  

  
VAR

  'variables for display
  long  col, row, color, flag
  word  boxptr
  byte boxcolor
  long  array[tiles/2]
  long  cursor_x, cursor_y, cursor_col, cursor_def
  long  sync                    



OBJ
  mouse : "mouse"  
  vga :  "VGA_1280x1024_Tile_Driver_With_cursor_Graph" 
  'kb : "keyboard"



PUB main|i,j,acnt,graph1xy, graph2xy


  'start mouse and set bound parameters
  mouse.start(24, 25)
  mouse.bound_limits(0, 0, 0, 1279, 1023, 0)
  mouse.bound_scales(1, 1, 0)
  mouse.bound_preset(200, 350, 0)
    
  'start VGA
  cursor_def := 0
  cursor_col :=  %%0330
  cursor_x:=10
  cursor_y:=765
  graph1xy:=100<<16+1023
  graph2xy:=400<<16+1023
  vga.start(16, @array, @vgacolors, @cursor_x,0,0,graph1xy,graph2xy)

  print($100) 'clear screen
 
  'start the keyboard
  'kb.start(26, 27)

  'title
  color:=0
  row:=0
  col:=50
  print_string(string("Strip Chart Demo"))

  row:=10
  col:=45
  print_string(string("Plotting 2048 points"))
  row:=12
  col:=45
  print_string(string("Using NO HUB RAM!!!"))
  
  acnt:=cnt
  i:=0
  repeat
    'graph dummy data and update mouse position
    cursor_x := mouse.bound_x
    cursor_y := mouse.bound_y
    if (cnt-acnt)>clkfreq/1024
      'Add new data point
      'j:=word[$E000][i//2049]>>9
      'j+=word[$C000][i*2//2048]>>10

      j:=128
      j+=sinusoid(i,20)
      j+=sinusoid(i/5,50)
      j+=sinusoid((i+643)*3,30)
      j+=sinusoid((i+1643)*10,10)      
      vga.Graph1Byte(j//256)
      
      j:=128
      j+=sinusoid((i+1800)*1,50)
      j+=sinusoid(i/9,20)
      j+=sinusoid((i+900)*4,40)
      j+=sinusoid((i+1643)*15,5)    
      vga.Graph2Byte(j//256)
      
      acnt:=cnt
      i++
    
  
PUB sinusoid(angleX10,multiplier)|sign,table
  'Quick attempt at sine
  angleX10:=angleX10//3600
  if angleX10>1800
    angleX10-=1800
    sign:=-1
  else
    sign:=1 
  if angleX10>900
    angleX10:=1800-angleX10

  table:=word[$E000][angleX10*2048/901]  
  
  return sign*multiplier*table/$FFFF 


PRI dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    print_string("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      print(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      print("0")
    i /= 10


PRI hex(value, digits)

'' Print a hexadecimal number

  value <<= (8 - digits) << 2
  repeat digits
    print(lookupz((value <-= 4) & $F : "0".."9", "A".."F"))


PRI bin(value, digits)

'' Print a binary number

  value <<= 32 - digits
  repeat digits
    print((value <-= 1) & 1 + "0")





PRI print_string(ptr)

  repeat while byte[ptr]
    print(byte[ptr++])
    

PRI print(c) | i, k

'' Print a character
''
''       $0D = new line
''  $10..$FF = character
''      $100 = clear screen
''      $101 = home
''      $108 = backspace
''$110..$11F = select color

  case c
    $0D:                'return?
      newline

    $10..$FF:           'character?
      k := color << 1 + c & 1
      i := $200 + (c & $FE) + k << 10
      array.word[row * cols + col] := i
      array.word[(row + 1) * cols + col] := i | 1
      if ++col == cols
        newline

    $100:               'clear screen?
      wordfill(@array, spacetile, tiles)
      col := row := 0

    $101:               'home?
      col := row := 0

    $108:               'backspace?
      if col
        col--

    $110..$11F:         'select color?
      color := c & $F


PRI newline | i

  col := 0
  if (row += 2) == rows
    row -= 2
    'scroll lines
    repeat i from 0 to rows-3
      wordmove(@array.word[i*cols], @array.word[(i+2)*cols], cols)
    'clear new line
    wordfill(@array.word[(rows-2)*cols], spacetile, cols<<1)


DAT

  

  'input to TV driver

  
tv_params long
                        long    0               'status
                        long    1               'enable
tv_pins                 long    0               'pins
                        long    %00010          'mode        (%00000 NON-INTERLACED, %00010 FOR INTERLACED)
tv_screen               long    0               'screen
tv_colors               long    0               'colors
                        long    cols            'hc
                        long    rows            'vc
                        long    4               'hx           (9 for 20)
                        long    1               'vx          (1 NON-INTERLACED 14, 2 FOR INTERLACED 14)
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog



 vgacolors long

'0..1:  text color 0:  
  long $F000F000'long $F010F010        '0: Yellow on black  
  long $F0F00000'long $F0F01010 
'2..3:  text color 1: 
  long $C0FCC0FC       ' red on white   
  long $C0C0FCFC
'4..5:  text color 2:        
  long $00FC00FC       'black on white  
  long $0000FCFC 
'6..7:  text color 3:     
  long $F010F010        '3: Yellow on Green  
  long $F0F01010 
'8..9:  text color 4:    
  long $00540054'$00A800A8      '4: black on grey  for box
  long $00005454'$0000A8A8 
'10:  graphics 0:  
  long $FC005454'$FF00A8A8         'box color gray  
'11:  graphics 1:  'light square   
  long %%3330_0000_0100_2100 '%%2100_2220_0100_0000         ' 
'12:  graphics 2:  'dark square
  long %%3330_0000_0100_1000        '  
'13:  graphics 3:  'highlight square
  long %%3330_0000_0100_1030        '
'14:  graphics 4:  'Start square
  long %%3330_0000_0100_3300        '
'15:  graphics 5:  'End square
  long %%3330_0000_0100_0330        '
'16:  cursor
        'long 0[4]
  long %%3300_2220_0100_0000
  long %%3300_2220_0100_0000
  long %%3300_2220_0100_0000
  long %%3300_2220_0100_0000
'21:  border

           